module Push
  class << self
    # 调用推送服务，推送信息
    # user_device_ids, 用户设备信息，可以是字符串数组，也可以是字符串。
    # message 要推送的具体信息
    # opts 是hash类型，主要是一些其他的信息。
    # 由于历史遗留问题,封装的不够好，这里主要用来处理个推的一些参数。
    # 目前华为推送，小米推送不会用到这里的信息。
    def push(user_device_ids, message, igetui_opts = {})
      Push::Log.info("push: user_device_ids: #{user_device_ids}, message: #{message}, igetui_opts: #{igetui_opts}")
      message = message.with_indifferent_access
      igetui_opts = igetui_opts.with_indifferent_access
      # igetui
      Push::Igetui.push(user_device_ids, message, igetui_opts)

      # xiaomi
      # https://dev.mi.com/console/doc/detail?pId=1163 文档中心
      Push::Xiaomi.push(user_device_ids, message)

      # huawei
      # https://developer.huawei.com/consumer/cn/service/hms/catalog/huaweipush_agent.html?page=hmssdk_huaweipush_api_reference_agent_s1 接入文档
      Push::Huawei.push(user_device_ids, message)

      # etc
    rescue StandardError => err
      Push::Log.error(err)
    end
  end
end
